# shell functions library
# to be sourced, not executed
# Copyright (c) 2013 Damyan Ivanov <dmn@debian.org>
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of either:
#     .
#    a) the GNU General Public License as published by the Free Software
#       Foundation; either version 1, or (at your option) any later
#       version, or
#                        .
#    b) the "Artistic License" which comes with Perl.
#
# the purpose of this is to hijack the 'dpt commit' invocation, parse its
# output, and thange the CWD accordingly

dpt() {
    REAL=`/usr/bin/which dpt`
    TMP=`mktemp -d`
    trap "command rm -rf '$TMP'" 0 INT TERM PIPE
    mkfifo "$TMP/pipe"
    (
    set +m
    tee "$TMP/out" < "$TMP/pipe" &
    )
    ES=0
    $REAL "$@" > "$TMP/pipe" || ES=$?

    [ "$ES" = "0" ] || return $ES

    if egrep -q "^Updating existing checkout in .+" "$TMP/out"; then
        DIR=`egrep '^Updating existing' "$TMP/out" | sed -e 's/Updating existing checkout in //'`
        cd "$DIR"
        return 0
    fi

    if egrep -q "^.+ ready in .+" "$TMP/out"; then
        DIR=`egrep ' ready in ' "$TMP/out" | sed -e 's/.\+ ready in //'`
        cd "$DIR"
        return 0
    fi

    return 0
}
